
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	EXPR_AND_AND	258
#define	EXPR_OR_OR	259
#define	EXPR_AND	260
#define	EXPR_OR	261
#define	EXPR_NOT	262
#define	EXPR_LT	263
#define	EXPR_LE	264
#define	EXPR_EQ	265
#define	EXPR_NE	266
#define	EXPR_GE	267
#define	EXPR_GT	268
#define	LEFTDIV	269
#define	EMUL	270
#define	EDIV	271
#define	ELEFTDIV	272
#define	EPLUS	273
#define	EMINUS	274
#define	QUOTE	275
#define	TRANSPOSE	276
#define	PLUS_PLUS	277
#define	MINUS_MINUS	278
#define	POW	279
#define	EPOW	280
#define	NUM	281
#define	IMAG_NUM	282
#define	NAME	283
#define	SCREW	284
#define	END	285
#define	PLOT	286
#define	TEXT	287
#define	STYLE	288
#define	FOR	289
#define	WHILE	290
#define	IF	291
#define	ELSEIF	292
#define	ELSE	293
#define	SWITCH	294
#define	CASE	295
#define	OTHERWISE	296
#define	BREAK	297
#define	CONTINUE	298
#define	FUNC_RET	299
#define	UNWIND	300
#define	CLEANUP	301
#define	TRY	302
#define	CATCH	303
#define	GLOBAL	304
#define	TEXT_ID	305
#define	LEXICAL_ERROR	306
#define	FCN	307
#define	SCREW_TWO	308
#define	ELLIPSIS	309
#define	ALL_VA_ARGS	310
#define	END_OF_INPUT	311
#define	USING	312
#define	TITLE	313
#define	WITH	314
#define	COLON	315
#define	OPEN_BRACE	316
#define	CLOSE_BRACE	317
#define	CLEAR	318
#define	UNARY	319

#line 29 "parse.y"

#define YYDEBUG 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef YYBYACC
#include <cstdlib>
#endif

#include <strstream.h>

#include "Matrix.h"

#include "defun.h"
#include "error.h"
#include "input.h"
#include "lex.h"
#include "oct-hist.h"
#include "toplev.h"
#include "pager.h"
#include "parse.h"
#include "pt-cmd.h"
#include "pt-const.h"
#include "pt-fcn.h"
#include "pt-fvc.h"
#include "pt-mat.h"
#include "pt-mvr.h"
#include "pt-exp.h"
#include "pt-misc.h"
#include "pt-plot.h"
#include "pt-pr-code.h"
#include "symtab.h"
#include "token.h"
#include "utils.h"
#include "variables.h"

// If TRUE, generate a warning for the assignment in things like
//
//   octave> if (a = 2 < n)
//
// but not
//
//   octave> if ((a = 2) < n)
//
static bool Vwarn_assign_as_truth_value;

// If TRUE, generate a warning for variable swich labels.
static bool Vwarn_variable_switch_label;

// If TRUE, generate a warning for the comma in things like
//
//   octave> global a, b = 2
//
static bool Vwarn_comma_in_global_decl;

// If TRUE, generate warning if declared function name disagrees with
// the name of the file in which it is defined.
static bool Vwarn_function_name_clash;

// If TRUE, generate warning if a statement in a function is not
// terminated with a semicolon.  Useful for checking functions that
// should only produce output using explicit printing statements.
static bool Vwarn_missing_semicolon;

// Temporary symbol table pointer used to cope with bogus function syntax.
symbol_table *tmp_local_sym_tab = 0;

// The current input line number.
int input_line_number = 0;

// The column of the current token.
int current_input_column = 1;

// Buffer for help text snagged from function files.
string help_buf;

// Forward declarations for some functions defined at the bottom of
// the file.

// Generic error messages.
static void yyerror (char *s);

// Error mesages for mismatched end tokens.
static void end_error (char *type, token::end_tok_type ettype, int l, int c);

// Check to see that end tokens are properly matched.
static int check_end (token *tok, token::end_tok_type expected);

// Try to figure out early if an expression should become an
// assignment to the built-in variable ans.
static tree_expression *maybe_convert_to_ans_assign (tree_expression *expr);

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.
static void maybe_warn_assign_as_truth_value (tree_expression *expr);

// Maybe print a warning about switch labels that aren't constants.
static void maybe_warn_variable_switch_label (tree_expression *expr);

// Create a plot command.
static tree_plot_command *make_plot_command
	 (token *tok, plot_limits *range, subplot_list *list);

// Finish building a range.
static tree_expression *finish_colon_expression (tree_colon_expression *e);

// Build a constant.
static tree_constant *make_constant (int op, token *tok_val);

// Build a binary expression.
static tree_expression *make_binary_op
	 (int op, tree_expression *op1,	token *tok_val, tree_expression *op2);

// Build a boolean expression.
static tree_expression *make_boolean_op
	 (int op, tree_expression *op1,	token *tok_val, tree_expression *op2);

// Build a prefix expression.
static tree_expression *make_prefix_op
	 (int op, tree_identifier *op1, token *tok_val);

// Build a postfix expression.
static tree_expression *make_postfix_op
	 (int op, tree_identifier *op1, token *tok_val);

// Build a binary expression.
static tree_expression *make_unary_op
	 (int op, tree_expression *op1, token *tok_val);

// Build an unwind-protect command.
static tree_command *make_unwind_command
	 (token *unwind_tok, tree_statement_list *body,
	  tree_statement_list *cleanup, token *end_tok);

// Build a try-catch command.
static tree_command *make_try_command
	 (token *try_tok, tree_statement_list *body,
	  tree_statement_list *cleanup, token *end_tok);

// Build a while command.
static tree_command *make_while_command
	 (token *while_tok, tree_expression *expr,
	  tree_statement_list *body, token *end_tok);

// Build a for command.
static tree_command *make_for_command
	 (token *for_tok, tree_index_expression *var,
	  tree_expression *expr, tree_statement_list *body,
	  token *end_tok);

// Build a for command a different way.
static tree_command *make_for_command
	 (token *for_tok, tree_matrix_row *mr, tree_expression *expr,
	  tree_statement_list *body, token *end_tok);

// Build a break command.
static tree_command *make_break_command (token *break_tok);

// Build a continue command.
static tree_command *make_continue_command (token *continue_tok);

// Build a return command.
static tree_command *make_return_command (token *return_tok);

// Start an if command.
static tree_if_command_list *start_if_command
	 (tree_expression *expr, tree_statement_list *list);

// Finish an if command.
static tree_if_command *finish_if_command
	 (token *if_tok, tree_if_command_list *list, token *end_tok);

// Build an elseif clause.
static tree_if_clause *make_elseif_clause
	 (tree_expression *expr, tree_statement_list *list);

// Finish a switch command.
static tree_switch_command *finish_switch_command
	 (token *switch_tok, tree_expression *expr,
	  tree_switch_case_list *list, token *end_tok);

// Build a switch case.
static tree_switch_case *make_switch_case
	 (tree_expression *expr, tree_statement_list *list);

// Build an assignment to a variable.
static tree_expression *make_simple_assignment
	 (tree_index_expression *var, token *eq_tok, tree_expression *expr);

// Make an expression that handles assignment of multiple values.
static tree_expression *make_multi_val_ret
	 (tree_matrix_row *mr, tree_expression *rhs, token *eq_tok);

// Begin defining a function.
static tree_function *start_function_def
	 (tree_parameter_list *param_list, tree_statement_list *body);

// Do most of the work for defining a function.
static tree_function *frob_function_def
	 (tree_identifier *id, tree_function *fcn);

// Finish defining a function.
static tree_function *finish_function_def (token *var, tree_function *fcn);

// Finish defining a function a different way.
static tree_function *finish_function_def
	 (tree_parameter_list *ret_list, tree_function *fcn);

// Make an index expression.
static tree_index_expression *make_index_expression
	 (tree_indirect_ref *indir, tree_argument_list *args);

// Finish building a matrix list.
static tree_expression *finish_matrix (tree_matrix *m);

// Maybe print a warning.  Duh.
static void maybe_warn_missing_semi (tree_statement_list *);

// Set the print flag for a statement based on the separator type.
static void set_stmt_print_flag (tree_statement_list *, char, bool);

#define ABORT_PARSE \
  do \
    { \
      global_command = 0; \
      yyerrok; \
      if (interactive || forced_interactive || really_forced_interactive) \
	YYACCEPT; \
      else \
	YYABORT; \
    } \
  while (0)


#line 268 "parse.y"
typedef union
{
// The type of the basic tokens returned by the lexer.
  token *tok_val;

// Types for the nonterminals we generate.
  char sep_type;
  tree *tree_type;
  tree_matrix *tree_matrix_type;
  tree_matrix_row *tree_matrix_row_type;
  tree_expression *tree_expression_type;
  tree_constant *tree_constant_type;
  tree_identifier *tree_identifier_type;
  tree_indirect_ref *tree_indirect_ref_type;
  tree_function *tree_function_type;
  tree_index_expression *tree_index_expression_type;
  tree_colon_expression *tree_colon_expression_type;
  tree_argument_list *tree_argument_list_type;
  tree_parameter_list *tree_parameter_list_type;
  tree_command *tree_command_type;
  tree_if_command *tree_if_command_type;
  tree_if_clause *tree_if_clause_type;
  tree_if_command_list *tree_if_command_list_type;
  tree_switch_command *tree_switch_command_type;
  tree_switch_case *tree_switch_case_type;
  tree_switch_case_list *tree_switch_case_list_type;
  tree_global *tree_global_type;
  tree_global_init_list *tree_global_init_list_type;
  tree_global_command *tree_global_command_type;
  tree_statement *tree_statement_type;
  tree_statement_list *tree_statement_list_type;
  tree_plot_command *tree_plot_command_type;
  subplot *subplot_type;
  subplot_list *subplot_list_type;
  plot_limits *plot_limits_type;
  plot_range *plot_range_type;
  subplot_using *subplot_using_type;
  subplot_style *subplot_style_type;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		359
#define	YYFLAG		-32768
#define	YYNTBASE	81

#define YYTRANSLATE(x) ((unsigned)(x) <= 319 ? yytranslate[x] : 155)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    72,
     2,     2,    73,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    74,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    77,
    78,     7,     6,    71,     5,    80,     8,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     4,    70,     2,
     3,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    76,     2,    79,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    75
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    13,    15,    17,    20,
    23,    26,    29,    31,    33,    36,    38,    42,    43,    45,
    48,    50,    54,    56,    58,    61,    64,    68,    70,    73,
    77,    83,    88,    93,    97,   100,   101,   103,   107,   109,
   112,   114,   116,   118,   121,   124,   127,   130,   133,   136,
   140,   144,   148,   152,   156,   160,   162,   165,   168,   172,
   175,   178,   182,   187,   189,   192,   194,   198,   200,   204,
   205,   207,   209,   211,   213,   215,   217,   225,   233,   239,
   247,   258,   260,   262,   264,   268,   270,   273,   277,   280,
   286,   290,   296,   298,   301,   303,   306,   312,   316,   317,
   319,   323,   325,   327,   329,   331,   335,   337,   339,   341,
   343,   346,   350,   353,   356,   359,   362,   365,   369,   376,
   379,   382,   385,   388,   392,   396,   400,   404,   408,   412,
   416,   420,   424,   428,   432,   436,   440,   444,   448,   452,
   456,   460,   464,   468,   472,   476,   480,   484,   487,   489,
   492,   493,   494,   495,   496,   497,   502,   507,   513,   518,
   523,   526,   530,   533,   538,   541,   544,   548,   553,   558,
   562,   564,   566,   568,   570,   571,   576,   578,   582,   587,
   590,   592,   594,   597,   601,   604,   609,   612,   616,   619,
   623,   625,   627,   629,   631,   635,   639,   643,   648,   650,
   653,   655,   659,   661,   664,   666,   670,   672,   674,   677,
   680,   681,   683,   685,   687,   689,   691,   694,   697,   700,
   703,   704
};

static const short yyrhs[] = {    82,
     0,    62,     0,    84,    83,     0,    83,     0,    72,     0,
    73,     0,    74,     0,    84,     0,    84,    72,     0,    84,
    73,     0,    84,    74,     0,    84,    62,     0,    57,     0,
     1,     0,    85,   152,     0,    89,     0,    85,   151,    89,
     0,     0,    87,     0,    88,   154,     0,    89,     0,    88,
   153,    89,     0,   105,     0,   100,     0,    37,    69,     0,
    37,    93,     0,    37,    91,    93,     0,    92,     0,    92,
    92,     0,    92,    92,    92,     0,    67,   117,    66,   117,
    68,     0,    67,    66,   117,    68,     0,    67,   117,    66,
    68,     0,    67,    66,    68,     0,    67,    68,     0,     0,
    94,     0,    93,    71,    94,     0,   117,     0,   117,    95,
     0,    96,     0,    98,     0,    99,     0,    96,    98,     0,
    98,    96,     0,    96,    99,     0,    99,    96,     0,    98,
    99,     0,    99,    98,     0,    96,    98,    99,     0,    96,
    99,    98,     0,    98,    96,    99,     0,    98,    99,    96,
     0,    99,    96,    98,     0,    99,    98,    96,     0,    97,
     0,    97,   117,     0,    63,   117,     0,    97,    66,   117,
     0,    64,   117,     0,    65,    39,     0,    65,    39,   117,
     0,    65,    39,   117,   117,     0,   117,     0,    55,   102,
     0,   103,     0,   102,   104,   103,     0,   144,     0,   144,
     3,   117,     0,     0,    71,     0,    90,     0,   128,     0,
   101,     0,   111,     0,   106,     0,    51,   154,    86,    52,
   154,    86,    36,     0,    53,   154,    86,    54,   154,    86,
    36,     0,    41,   117,   154,    86,    36,     0,    40,   139,
     3,   117,   154,    86,    36,     0,    40,    76,   116,   149,
    59,     3,   117,   154,    86,    36,     0,    48,     0,    49,
     0,    50,     0,    42,   107,    36,     0,   108,     0,   108,
   110,     0,   117,   154,    86,     0,   108,   109,     0,    43,
   154,   117,   154,    86,     0,    44,   154,    86,     0,    45,
   117,   154,   112,    36,     0,   113,     0,   113,   115,     0,
   114,     0,   113,   114,     0,    46,   154,   117,   154,    87,
     0,    47,   154,    86,     0,     0,   118,     0,    32,     3,
   117,     0,   119,     0,    32,     0,    33,     0,    38,     0,
    77,   118,    78,     0,   121,     0,   139,     0,   120,     0,
   146,     0,    76,    79,     0,    76,    70,    79,     0,    28,
   144,     0,    29,   144,     0,    13,   118,     0,     6,   118,
     0,     5,   118,     0,   139,     3,   118,     0,    76,   116,
   149,    59,     3,   118,     0,   144,    28,     0,   144,    29,
     0,   118,    26,     0,   118,    27,     0,   118,    30,   118,
     0,   118,    31,   118,     0,   118,     6,   118,     0,   118,
     5,   118,     0,   118,     7,   118,     0,   118,     8,   118,
     0,   118,    24,   118,     0,   118,    25,   118,     0,   118,
    21,   118,     0,   118,    22,   118,     0,   118,    20,   118,
     0,   118,    23,   118,     0,   118,    14,   118,     0,   118,
    15,   118,     0,   118,    16,   118,     0,   118,    18,   118,
     0,   118,    19,   118,     0,   118,    17,   118,     0,   118,
    11,   118,     0,   118,    12,   118,     0,   118,     9,   118,
     0,   118,    10,   118,     0,   118,     4,   118,     0,   120,
     4,   118,     0,   144,   122,     0,    38,     0,   122,    38,
     0,     0,     0,     0,     0,     0,    58,   123,   127,   129,
     0,    58,   123,   127,   133,     0,    35,   126,   123,     3,
   133,     0,   131,   123,     3,   133,     0,    76,   126,   125,
   124,     0,   130,    79,     0,   130,    60,    79,     0,   132,
    79,     0,   132,    71,    60,    79,     0,   130,   144,     0,
   130,     1,     0,   132,    71,   144,     0,   144,   126,   125,
   134,     0,   142,   154,    86,   135,     0,   154,    86,   135,
     0,    36,     0,    62,     0,   137,     0,   144,     0,     0,
   137,    80,   138,    56,     0,   136,     0,   136,    77,    78,
     0,   136,    77,   145,    78,     0,   136,    76,     0,    77,
     0,    78,     0,   140,   141,     0,   140,    60,   141,     0,
   143,   141,     0,   143,    71,    60,   141,     0,   140,   144,
     0,   143,    71,   144,     0,   140,     1,     0,   143,    71,
     1,     0,    34,     0,     4,     0,   117,     0,    61,     0,
   145,    71,     4,     0,   145,    71,   117,     0,   145,    71,
    61,     0,    76,   116,   147,    79,     0,   148,     0,   148,
    70,     0,   149,     0,   148,    70,   149,     0,   150,     0,
   150,    71,     0,   117,     0,   150,    71,   117,     0,    71,
     0,    70,     0,   151,    71,     0,   151,    70,     0,     0,
   151,     0,    71,     0,    70,     0,    72,     0,    73,     0,
   153,    71,     0,   153,    70,     0,   153,    72,     0,   153,
    73,     0,     0,   153,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   398,   404,   410,   412,   416,   418,   420,   422,   424,   426,
   428,   430,   434,   436,   439,   446,   448,   456,   458,   462,
   469,   474,   482,   484,   486,   494,   499,   506,   508,   510,
   514,   516,   518,   520,   522,   526,   528,   530,   537,   539,
   543,   545,   547,   549,   551,   553,   555,   557,   559,   561,
   563,   565,   567,   569,   571,   575,   580,   587,   592,   596,
   600,   602,   604,   608,   612,   619,   621,   627,   629,   638,
   639,   647,   649,   651,   653,   655,   657,   662,   667,   672,
   677,   683,   688,   693,   700,   707,   709,   716,   718,   725,
   729,   733,   740,   742,   749,   751,   758,   762,   766,   770,
   772,   783,   790,   792,   794,   796,   801,   803,   805,   807,
   809,   811,   813,   815,   817,   819,   821,   823,   825,   830,
   832,   834,   836,   838,   840,   842,   844,   846,   848,   850,
   852,   854,   856,   858,   860,   862,   864,   866,   868,   870,
   872,   874,   876,   878,   880,   884,   889,   896,   903,   908,
   918,   922,   926,   930,   934,   938,   944,   952,   954,   958,
   961,   966,   973,   978,   986,   988,   994,  1001,  1008,  1010,
  1014,  1022,  1029,  1035,  1040,  1042,  1045,  1047,  1049,  1051,
  1060,  1064,  1068,  1073,  1080,  1087,  1097,  1099,  1104,  1110,
  1118,  1125,  1131,  1133,  1139,  1146,  1151,  1160,  1164,  1166,
  1170,  1172,  1179,  1181,  1185,  1187,  1194,  1196,  1198,  1200,
  1204,  1206,  1210,  1212,  1214,  1216,  1218,  1220,  1222,  1224,
  1228,  1230
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","'='","':'",
"'-'","'+'","'*'","'/'","EXPR_AND_AND","EXPR_OR_OR","EXPR_AND","EXPR_OR","EXPR_NOT",
"EXPR_LT","EXPR_LE","EXPR_EQ","EXPR_NE","EXPR_GE","EXPR_GT","LEFTDIV","EMUL",
"EDIV","ELEFTDIV","EPLUS","EMINUS","QUOTE","TRANSPOSE","PLUS_PLUS","MINUS_MINUS",
"POW","EPOW","NUM","IMAG_NUM","NAME","SCREW","END","PLOT","TEXT","STYLE","FOR",
"WHILE","IF","ELSEIF","ELSE","SWITCH","CASE","OTHERWISE","BREAK","CONTINUE",
"FUNC_RET","UNWIND","CLEANUP","TRY","CATCH","GLOBAL","TEXT_ID","LEXICAL_ERROR",
"FCN","SCREW_TWO","ELLIPSIS","ALL_VA_ARGS","END_OF_INPUT","USING","TITLE","WITH",
"COLON","OPEN_BRACE","CLOSE_BRACE","CLEAR","';'","','","'\\n'","'\\r'","'\\032'",
"UNARY","'['","'('","')'","']'","'.'","input","input1","parse_error","simple_list",
"simple_list1","opt_list","list","list1","statement","plot_command","ranges",
"ranges1","plot_command1","plot_command2","plot_options","using","using1","title",
"style","ans_expression","global_decl","global_decl1","global_decl2","optcomma",
"command","if_command","if_cmd_list","if_cmd_list1","elseif_clause","else_clause",
"switch_command","case_list","case_list1","switch_case","default_case","screwed_again",
"expression","simple_expr","simple_expr1","colon_expr","word_list_cmd","word_list",
"g_symtab","in_return_list","local_symtab","safe","are_we_screwed","func_def",
"func_def1","return_list_x","return_list","return_list1","func_def2","func_def3",
"fcn_end_or_eof","indirect_ref","indirect_ref1","@1","variable","param_list_beg",
"param_list_end","param_list","param_list1","identifier","arg_list","matrix",
"rows","rows1","matrix_row","matrix_row1","sep_no_nl","opt_sep_no_nl","sep",
"opt_sep", NULL
};
#endif

static const short yyr1[] = {     0,
    81,    81,    81,    81,    82,    82,    82,    82,    82,    82,
    82,    82,    83,    83,    84,    85,    85,    86,    86,    87,
    88,    88,    89,    89,    89,    90,    90,    91,    91,    91,
    92,    92,    92,    92,    92,    93,    93,    93,    94,    94,
    95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
    95,    95,    95,    95,    95,    96,    96,    97,    97,    98,
    99,    99,    99,   100,   101,   102,   102,   103,   103,   104,
   104,   105,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   106,   107,   107,   108,   108,   109,
   110,   111,   112,   112,   113,   113,   114,   115,   116,   117,
   117,   118,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   120,   120,   121,   122,   122,
   123,   124,   125,   126,   127,   128,   128,   129,   129,   130,
   131,   131,   131,   131,   132,   132,   132,   133,   134,   134,
   135,   135,   136,   137,   138,   137,   139,   139,   139,   139,
   140,   141,   142,   142,   142,   142,   143,   143,   143,   143,
   144,   145,   145,   145,   145,   145,   145,   146,   147,   147,
   148,   148,   149,   149,   150,   150,   151,   151,   151,   151,
   152,   152,   153,   153,   153,   153,   153,   153,   153,   153,
   154,   154
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     1,     1,     1,     2,     2,
     2,     2,     1,     1,     2,     1,     3,     0,     1,     2,
     1,     3,     1,     1,     2,     2,     3,     1,     2,     3,
     5,     4,     4,     3,     2,     0,     1,     3,     1,     2,
     1,     1,     1,     2,     2,     2,     2,     2,     2,     3,
     3,     3,     3,     3,     3,     1,     2,     2,     3,     2,
     2,     3,     4,     1,     2,     1,     3,     1,     3,     0,
     1,     1,     1,     1,     1,     1,     7,     7,     5,     7,
    10,     1,     1,     1,     3,     1,     2,     3,     2,     5,
     3,     5,     1,     2,     1,     2,     5,     3,     0,     1,
     3,     1,     1,     1,     1,     3,     1,     1,     1,     1,
     2,     3,     2,     2,     2,     2,     2,     3,     6,     2,
     2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     2,     1,     2,
     0,     0,     0,     0,     0,     4,     4,     5,     4,     4,
     2,     3,     2,     4,     2,     2,     3,     4,     4,     3,
     1,     1,     1,     1,     0,     4,     1,     3,     4,     2,
     1,     1,     2,     3,     2,     4,     2,     3,     2,     3,
     1,     1,     1,     1,     3,     3,     3,     4,     1,     2,
     1,     3,     1,     2,     1,     3,     1,     1,     2,     2,
     0,     1,     1,     1,     1,     1,     2,     2,     2,     2,
     0,     1
};

static const short yydefact[] = {     0,
    14,     0,     0,     0,     0,     0,   103,   104,   191,    36,
   105,     0,     0,     0,     0,    82,    83,    84,   221,   221,
     0,    13,   151,     2,     5,     6,     7,    99,     0,     1,
     4,     0,   211,    16,    72,    24,    74,    23,    76,    75,
    64,   100,   102,   109,   107,    73,   177,   173,   108,   174,
   110,   103,   117,   116,   115,   113,   114,     0,     0,    25,
    36,    28,    26,    37,    39,    99,     0,   174,   221,     0,
    86,   221,   221,   214,   213,   215,   216,   222,    18,    18,
    65,    66,    68,   155,     0,   111,     0,     0,    12,     9,
    10,    11,     3,   208,   207,   212,    15,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   122,   123,
     0,     0,     0,   180,     0,   175,     0,   120,   121,   149,
   148,   101,     0,    35,     0,    27,    29,     0,     0,     0,
     0,    40,    41,    56,    42,    43,     0,     0,    18,    85,
   221,   221,    89,    87,    18,     0,   218,   217,   219,   220,
     0,    19,   221,    21,     0,    71,     0,     0,     0,   112,
   205,     0,   199,   201,   203,   106,   210,   209,    17,   146,
   127,   126,   128,   129,   144,   145,   142,   143,   136,   137,
   138,   141,   139,   140,   134,   132,   133,   135,   130,   131,
   124,   125,   147,   192,   194,   178,   193,     0,     0,   118,
   150,    34,     0,     0,    30,    38,    58,    60,    61,    44,
    46,     0,    57,    45,    48,    47,    49,     0,   221,     0,
     0,    18,    88,   221,     0,    93,    95,   221,   222,    20,
   221,    67,    69,   154,   154,   156,     0,   151,     0,   157,
   154,   198,   200,     0,   204,     0,   179,   176,    32,    33,
     0,    62,    50,    51,    59,    52,    53,    54,    55,     0,
    18,    79,   221,    91,     0,    92,   221,    96,    94,    18,
    22,    18,   151,   153,   166,     0,   161,   165,     0,     0,
   163,   153,   202,     0,   206,   195,   197,   196,    31,    63,
     0,     0,    18,   221,    18,     0,     0,     0,   152,   162,
     0,     0,   167,   221,   119,   221,    80,    90,     0,    98,
    77,    78,     0,   160,   159,   164,   181,   168,     0,   221,
     0,    18,    18,    97,   158,   189,     0,   182,   183,   187,
    18,     0,   185,     0,     0,   184,     0,   190,     0,   188,
   171,   172,   170,    81,   169,   186,     0,     0,     0
};

static const short yydefgoto[] = {   357,
    30,    31,    32,    33,   161,   162,   163,   164,    35,    61,
    62,    63,    64,   142,   143,   144,   145,   146,    36,    37,
    81,    82,   167,    38,    39,    70,    71,   153,   154,    40,
   235,   236,   237,   279,    87,    41,    42,    43,    44,    45,
   131,    84,   324,   309,   283,   169,    46,   246,   247,   248,
   249,   250,   328,   353,    47,    48,   209,    49,   329,   339,
   330,   331,    50,   208,    51,   172,   173,   174,   175,    96,
    97,    78,    79
};

static const short yypact[] = {   356,
-32768,   684,   684,   684,     9,     9,    58,-32768,-32768,   297,
-32768,   -16,   721,   721,   721,-32768,-32768,-32768,     7,     7,
     9,-32768,-32768,-32768,-32768,-32768,-32768,   -42,   684,-32768,
-32768,    75,   -13,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   758,-32768,    42,-32768,-32768,   -10,    41,    61,     6,
-32768,-32768,    51,    51,    51,-32768,-32768,   721,   604,-32768,
   721,    63,    65,-32768,    32,-32768,    69,-32768,     7,   110,
    45,     7,     7,-32768,-32768,-32768,-32768,    71,   563,   563,
   -12,-32768,   152,-32768,    81,-32768,   721,   430,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   512,-32768,   684,   684,   684,
   684,   684,   684,   684,   684,   684,   684,   684,   684,   684,
   684,   684,   684,   684,   684,   684,   684,   684,-32768,-32768,
   684,   684,   684,-32768,   167,-32768,   684,-32768,-32768,-32768,
   123,-32768,   617,-32768,    97,    65,    63,   721,   721,   721,
   126,-32768,    28,   654,    91,    62,   721,   721,   563,-32768,
     7,     7,-32768,-32768,   563,   120,-32768,-32768,-32768,-32768,
   116,-32768,     7,-32768,   115,-32768,     9,   721,   -14,-32768,
-32768,    95,   100,   117,   104,-32768,-32768,-32768,-32768,   457,
   865,   865,    43,    43,   788,   788,   816,   816,   844,   844,
   844,   844,   844,   844,    43,    43,    43,    43,   865,   865,
    51,    51,   457,-32768,-32768,-32768,-32768,   -31,   121,   758,
-32768,-32768,   111,   671,-32768,-32768,-32768,-32768,   721,   113,
   118,   721,-32768,   113,   122,   118,   122,   128,     7,   145,
   721,   563,-32768,     7,   153,   112,-32768,     7,   461,-32768,
     7,-32768,-32768,-32768,-32768,-32768,     8,-32768,   -46,-32768,
-32768,-32768,   721,   185,   721,   228,-32768,-32768,-32768,-32768,
   124,   721,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   187,
   563,-32768,     7,-32768,   721,-32768,     7,-32768,-32768,   563,
-32768,   563,-32768,-32768,-32768,   114,-32768,-32768,   188,    -8,
-32768,-32768,-32768,   684,-32768,-32768,-32768,-32768,-32768,-32768,
   721,   158,   563,     7,   563,   161,   162,   199,-32768,-32768,
     9,   129,-32768,    80,   758,     7,-32768,-32768,   563,-32768,
-32768,-32768,     9,-32768,-32768,-32768,-32768,-32768,     5,     7,
   -15,   563,   563,-32768,-32768,-32768,   131,-32768,-32768,-32768,
   563,    11,-32768,    -9,   168,-32768,    -9,-32768,   131,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   203,   207,-32768
};

static const short yypgoto[] = {-32768,
-32768,   178,-32768,-32768,   -65,  -106,-32768,    31,-32768,-32768,
   -52,   157,    76,-32768,   -96,-32768,  -135,  -126,-32768,-32768,
-32768,    52,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -11,-32768,   155,   125,     1,-32768,-32768,-32768,
-32768,  -235,-32768,   -70,  -213,-32768,-32768,-32768,-32768,-32768,
-32768,  -287,-32768,  -123,-32768,-32768,-32768,   214,-32768,  -308,
-32768,-32768,    -5,-32768,-32768,-32768,-32768,  -133,-32768,-32768,
-32768,    64,   -18
};


#define	YYLAST		896


static const short yytable[] = {    56,
    57,    80,    53,    54,    55,   336,    68,   220,   285,   137,
   227,   348,   289,   228,   165,    83,   221,     9,   225,     9,
   244,   -70,   343,   325,   290,     9,   351,    85,   346,    88,
    34,   284,   291,   128,   129,   335,    86,   292,     9,   256,
   356,     9,     9,   130,     9,   123,   257,   308,   224,   226,
   149,   312,   352,   155,   156,   342,    94,    95,   166,    66,
    58,   245,   338,   127,   337,   124,   125,   286,   119,   120,
   349,   148,   121,   122,    -8,     1,    74,    75,    76,    77,
   121,   122,   338,   230,   215,   264,   287,   151,   152,   233,
   268,   140,   141,   263,   139,   140,   141,   266,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
   192,   193,   194,   195,   196,   197,   198,   199,   200,   293,
   126,   201,   202,   203,   139,   140,   179,   210,   267,    59,
   269,    22,   231,   232,    65,   138,    89,    69,    72,    73,
   157,   158,   159,   160,   240,   150,    90,    91,    92,    74,
    75,    76,    77,   139,   168,   141,   327,   234,   277,   170,
   211,    83,   214,   251,   219,   234,   274,   238,   241,   253,
   204,     2,     3,   252,   255,   254,   258,   141,   259,     4,
   272,   140,   132,   135,   139,    65,   270,   294,   276,   301,
   311,   299,   310,   317,     5,     6,   321,   322,     7,     8,
     9,   323,   358,   354,    11,   302,   359,   326,   338,    93,
   271,   171,   334,   216,   306,   275,   307,   136,   242,   280,
   147,   314,   282,   355,   278,    67,   239,   205,     0,     0,
     0,   296,     2,     3,     0,     0,     0,   318,     0,   320,
     4,   288,    28,    29,   206,     0,     0,     0,     0,   207,
     0,     0,     0,     0,   303,     5,     6,   213,   305,     7,
     8,     9,    65,   217,   218,    11,   344,   345,   223,   281,
     0,   171,   229,     0,     0,   347,     0,     0,     0,     0,
     0,     0,     0,     0,   313,   319,     0,     0,   297,     0,
     0,     0,   243,     0,   315,   332,     0,   333,     0,     0,
     0,     2,     3,    28,    29,   251,     0,     0,     0,     4,
     0,   341,     0,     0,     0,     0,     0,   251,     0,     0,
     0,     0,     0,   340,     5,     6,     0,     0,     7,     8,
     9,     0,     0,     0,    11,     0,   350,     0,   261,     0,
     0,     0,     0,   262,     0,     0,   265,     0,     0,     0,
     0,     0,     0,     0,     0,   273,     1,     0,     0,     0,
     2,     3,     0,    59,     0,    60,     0,     0,     4,     0,
     0,     0,    28,    29,     0,     0,     0,   171,     0,   295,
   298,     0,     0,     5,     6,     0,   300,     7,     8,     9,
     0,     0,    10,    11,     0,    12,    13,    14,     0,   304,
    15,     0,     0,    16,    17,    18,    19,     0,    20,     0,
    21,     0,    22,    23,     0,     0,     0,    24,     0,     0,
     0,     0,     0,     0,     0,   316,     0,    25,    26,    27,
     0,    28,    29,    98,    99,   100,   101,   102,   103,   104,
   105,   106,     0,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   120,     0,     0,   121,
   122,    99,   100,   101,   102,     2,     3,     0,     0,     0,
     0,     0,     0,     4,     0,     0,   113,   114,   115,   116,
   117,   118,   119,   120,     0,     0,   121,   122,     5,     6,
     0,     0,     7,     8,     9,     0,     0,    10,    11,     0,
    12,    13,    14,     0,     0,    15,     0,   176,    16,    17,
    18,    19,     0,    20,     0,    21,     2,     3,    23,     0,
     0,     0,     0,     0,     4,     0,     0,     0,     0,     0,
   157,   158,   159,   160,     0,     0,    28,    29,     0,     5,
     6,     0,     0,     7,     8,     9,     0,     0,    10,    11,
     0,    12,    13,    14,     0,     0,    15,     0,     0,    16,
    17,    18,    19,     0,    20,     0,    21,     2,     3,    23,
     0,     0,     0,     0,     0,     4,     0,     0,     0,     0,
     0,   177,   178,     0,     0,     0,     0,    28,    29,     0,
     5,     6,     0,     0,     7,     8,     9,     0,     0,    10,
    11,     0,    12,    13,    14,     0,     0,    15,     2,     3,
    16,    17,    18,    19,     0,    20,     4,    21,     0,     0,
    23,     2,     3,     0,     0,     0,     0,     0,     0,     4,
     0,     5,     6,     0,     0,     7,     8,     9,    28,    29,
     0,    11,     0,     0,     5,     6,     0,     0,     7,     8,
     9,     0,     0,     0,    11,     0,     0,     0,     2,     3,
     0,     0,     0,     0,     0,     0,     4,     0,     0,   133,
     0,   134,     0,     0,     0,     2,     3,     0,     0,    28,
    29,     5,     6,     4,   212,     7,     8,     9,     2,     3,
     0,    11,    28,    29,     0,     0,     4,     0,     5,     6,
     0,     0,     7,     8,     9,     0,     0,     0,    11,     0,
     0,     5,     6,     0,     0,    52,     8,     9,     0,   222,
     0,    11,     0,     0,     0,     2,     3,     0,     0,    28,
    29,     0,     0,     4,     0,     0,     0,     0,   260,     0,
     0,     0,     0,     0,     0,     0,    28,    29,     5,     6,
     0,     0,     7,     8,     9,     0,     0,     0,    11,    28,
    29,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     0,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,   120,     0,     0,   121,   122,     0,
     0,    98,    99,   100,   101,   102,    28,    29,   105,   106,
     0,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,   120,     0,     0,   121,   122,    98,
    99,   100,   101,   102,     0,     0,     0,     0,     0,   107,
   108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
   118,   119,   120,     0,     0,   121,   122,    98,    99,   100,
   101,   102,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   113,   114,   115,   116,   117,   118,   119,
   120,   101,   102,   121,   122,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   113,   114,   115,   116,     0,     0,
   119,   120,     0,     0,   121,   122
};

static const short yycheck[] = {     5,
     6,    20,     2,     3,     4,     1,    12,   143,     1,    62,
   146,     1,   248,   147,    80,    21,   143,    34,   145,    34,
    35,    34,   331,   311,    71,    34,    36,    70,   337,    29,
     0,   245,    79,    28,    29,   323,    79,   251,    34,    71,
   349,    34,    34,    38,    34,     4,    78,   283,   145,   146,
    69,    60,    62,    72,    73,    71,    70,    71,    71,    76,
     3,    76,    78,     3,    60,    76,    77,    60,    26,    27,
    60,     3,    30,    31,     0,     1,    70,    71,    72,    73,
    30,    31,    78,   149,   137,   221,    79,    43,    44,   155,
   226,    64,    65,   220,    63,    64,    65,   224,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   253,
    80,   121,   122,   123,    63,    64,    96,   127,   225,    67,
   227,    57,   151,   152,    10,    71,    62,    13,    14,    15,
    70,    71,    72,    73,   163,    36,    72,    73,    74,    70,
    71,    72,    73,    63,     3,    65,    77,    46,    47,    79,
    38,   167,    66,   169,    39,    46,   232,    52,    54,    70,
     4,     5,     6,    79,    71,    59,    56,    65,    68,    13,
    36,    64,    58,    59,    63,    61,    59,     3,    36,     3,
     3,    68,    79,    36,    28,    29,    36,    36,    32,    33,
    34,     3,     0,    36,    38,   271,     0,    79,    78,    32,
   229,    87,   319,   138,   280,   234,   282,    61,   167,   238,
    66,   292,   241,   347,   236,    12,   163,    61,    -1,    -1,
    -1,     4,     5,     6,    -1,    -1,    -1,   303,    -1,   305,
    13,   247,    76,    77,    78,    -1,    -1,    -1,    -1,   125,
    -1,    -1,    -1,    -1,   273,    28,    29,   133,   277,    32,
    33,    34,   138,   139,   140,    38,   332,   333,   144,   239,
    -1,   147,   148,    -1,    -1,   341,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   290,   304,    -1,    -1,    61,    -1,
    -1,    -1,   168,    -1,   294,   314,    -1,   316,    -1,    -1,
    -1,     5,     6,    76,    77,   311,    -1,    -1,    -1,    13,
    -1,   330,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
    -1,    -1,    -1,   329,    28,    29,    -1,    -1,    32,    33,
    34,    -1,    -1,    -1,    38,    -1,   342,    -1,   214,    -1,
    -1,    -1,    -1,   219,    -1,    -1,   222,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   231,     1,    -1,    -1,    -1,
     5,     6,    -1,    67,    -1,    69,    -1,    -1,    13,    -1,
    -1,    -1,    76,    77,    -1,    -1,    -1,   253,    -1,   255,
   256,    -1,    -1,    28,    29,    -1,   262,    32,    33,    34,
    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,   275,
    45,    -1,    -1,    48,    49,    50,    51,    -1,    53,    -1,
    55,    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   301,    -1,    72,    73,    74,
    -1,    76,    77,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    -1,    -1,    30,
    31,     5,     6,     7,     8,     5,     6,    -1,    -1,    -1,
    -1,    -1,    -1,    13,    -1,    -1,    20,    21,    22,    23,
    24,    25,    26,    27,    -1,    -1,    30,    31,    28,    29,
    -1,    -1,    32,    33,    34,    -1,    -1,    37,    38,    -1,
    40,    41,    42,    -1,    -1,    45,    -1,    78,    48,    49,
    50,    51,    -1,    53,    -1,    55,     5,     6,    58,    -1,
    -1,    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,
    70,    71,    72,    73,    -1,    -1,    76,    77,    -1,    28,
    29,    -1,    -1,    32,    33,    34,    -1,    -1,    37,    38,
    -1,    40,    41,    42,    -1,    -1,    45,    -1,    -1,    48,
    49,    50,    51,    -1,    53,    -1,    55,     5,     6,    58,
    -1,    -1,    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,
    -1,    70,    71,    -1,    -1,    -1,    -1,    76,    77,    -1,
    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    37,
    38,    -1,    40,    41,    42,    -1,    -1,    45,     5,     6,
    48,    49,    50,    51,    -1,    53,    13,    55,    -1,    -1,
    58,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    13,
    -1,    28,    29,    -1,    -1,    32,    33,    34,    76,    77,
    -1,    38,    -1,    -1,    28,    29,    -1,    -1,    32,    33,
    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,     5,     6,
    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,    -1,    66,
    -1,    68,    -1,    -1,    -1,     5,     6,    -1,    -1,    76,
    77,    28,    29,    13,    68,    32,    33,    34,     5,     6,
    -1,    38,    76,    77,    -1,    -1,    13,    -1,    28,    29,
    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    38,    -1,
    -1,    28,    29,    -1,    -1,    32,    33,    34,    -1,    66,
    -1,    38,    -1,    -1,    -1,     5,     6,    -1,    -1,    76,
    77,    -1,    -1,    13,    -1,    -1,    -1,    -1,    68,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    28,    29,
    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    38,    76,
    77,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    -1,    -1,    30,    31,    -1,
    -1,     4,     5,     6,     7,     8,    76,    77,    11,    12,
    -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    -1,    -1,    30,    31,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    -1,    -1,    30,    31,     4,     5,     6,
     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
    27,     7,     8,    30,    31,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
    26,    27,    -1,    -1,    30,    31
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 399 "parse.y"
{
		    global_command = yyvsp[0].tree_statement_list_type;
		    promptflag = 1;
		    YYACCEPT;
		  ;
    break;}
case 2:
#line 405 "parse.y"
{
		    global_command = 0;
		    promptflag = 1;
		    YYABORT;
		  ;
    break;}
case 3:
#line 411 "parse.y"
{ ABORT_PARSE; ;
    break;}
case 4:
#line 413 "parse.y"
{ ABORT_PARSE; ;
    break;}
case 5:
#line 417 "parse.y"
{ yyval.tree_statement_list_type = 0; ;
    break;}
case 6:
#line 419 "parse.y"
{ yyval.tree_statement_list_type = 0; ;
    break;}
case 7:
#line 421 "parse.y"
{ yyval.tree_statement_list_type = 0; ;
    break;}
case 8:
#line 423 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[0].tree_statement_list_type; ;
    break;}
case 9:
#line 425 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 10:
#line 427 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 11:
#line 429 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 12:
#line 431 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 13:
#line 435 "parse.y"
{ yyerror ("parse error"); ;
    break;}
case 15:
#line 440 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-1].tree_statement_list_type, yyvsp[0].sep_type, false);
		    yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type;
		  ;
    break;}
case 16:
#line 447 "parse.y"
{ yyval.tree_statement_list_type = new tree_statement_list (yyvsp[0].tree_statement_type); ;
    break;}
case 17:
#line 449 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-2].tree_statement_list_type, yyvsp[-1].sep_type, false);
		    yyvsp[-2].tree_statement_list_type->append (yyvsp[0].tree_statement_type);
		    yyval.tree_statement_list_type = yyvsp[-2].tree_statement_list_type;
		  ;
    break;}
case 18:
#line 457 "parse.y"
{ yyval.tree_statement_list_type = new tree_statement_list (); ;
    break;}
case 19:
#line 459 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[0].tree_statement_list_type; ;
    break;}
case 20:
#line 463 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-1].tree_statement_list_type, yyvsp[0].sep_type, true);
		    yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type;
		  ;
    break;}
case 21:
#line 470 "parse.y"
{
		    lexer_flags.beginning_of_function = 0;
		    yyval.tree_statement_list_type = new tree_statement_list (yyvsp[0].tree_statement_type);
		  ;
    break;}
case 22:
#line 475 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-2].tree_statement_list_type, yyvsp[-1].sep_type, true);
		    yyvsp[-2].tree_statement_list_type->append (yyvsp[0].tree_statement_type);
		    yyval.tree_statement_list_type = yyvsp[-2].tree_statement_list_type;
		  ;
    break;}
case 23:
#line 483 "parse.y"
{ yyval.tree_statement_type = new tree_statement (yyvsp[0].tree_command_type); ;
    break;}
case 24:
#line 485 "parse.y"
{ yyval.tree_statement_type = new tree_statement (yyvsp[0].tree_expression_type); ;
    break;}
case 25:
#line 487 "parse.y"
{
		    symbol_record *sr = lookup_by_name ("clearplot", 0);
		    tree_identifier *id = new tree_identifier (sr);
		    yyval.tree_statement_type = new tree_statement (id);
		  ;
    break;}
case 26:
#line 495 "parse.y"
{
		    if (! (yyval.tree_plot_command_type = make_plot_command (yyvsp[-1].tok_val, 0, yyvsp[0].subplot_list_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 27:
#line 500 "parse.y"
{
		    if (! (yyval.tree_plot_command_type = make_plot_command (yyvsp[-2].tok_val, yyvsp[-1].plot_limits_type, yyvsp[0].subplot_list_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 28:
#line 507 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[0].plot_range_type); ;
    break;}
case 29:
#line 509 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[-1].plot_range_type, yyvsp[0].plot_range_type); ;
    break;}
case 30:
#line 511 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[-2].plot_range_type, yyvsp[-1].plot_range_type, yyvsp[0].plot_range_type); ;
    break;}
case 31:
#line 515 "parse.y"
{ yyval.plot_range_type = new plot_range (yyvsp[-3].tree_expression_type, yyvsp[-1].tree_expression_type); ;
    break;}
case 32:
#line 517 "parse.y"
{ yyval.plot_range_type = new plot_range (0, yyvsp[-1].tree_expression_type); ;
    break;}
case 33:
#line 519 "parse.y"
{ yyval.plot_range_type = new plot_range (yyvsp[-2].tree_expression_type, 0); ;
    break;}
case 34:
#line 521 "parse.y"
{ yyval.plot_range_type = new plot_range (); ;
    break;}
case 35:
#line 523 "parse.y"
{ yyval.plot_range_type = new plot_range (); ;
    break;}
case 36:
#line 527 "parse.y"
{ yyval.subplot_list_type = 0; ;
    break;}
case 37:
#line 529 "parse.y"
{ yyval.subplot_list_type = new subplot_list (yyvsp[0].subplot_type); ;
    break;}
case 38:
#line 531 "parse.y"
{
		    yyvsp[-2].subplot_list_type->append (yyvsp[0].subplot_type);
		    yyval.subplot_list_type = yyvsp[-2].subplot_list_type;
		  ;
    break;}
case 39:
#line 538 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].tree_expression_type); ;
    break;}
case 40:
#line 540 "parse.y"
{ yyval.subplot_type = yyvsp[0].subplot_type->set_data (yyvsp[-1].tree_expression_type); ;
    break;}
case 41:
#line 544 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, 0, 0); ;
    break;}
case 42:
#line 546 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[0].tree_expression_type, 0); ;
    break;}
case 43:
#line 548 "parse.y"
{ yyval.subplot_type = new subplot (0, 0, yyvsp[0].subplot_style_type); ;
    break;}
case 44:
#line 550 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[0].tree_expression_type, 0); ;
    break;}
case 45:
#line 552 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-1].tree_expression_type, 0); ;
    break;}
case 46:
#line 554 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, 0, yyvsp[0].subplot_style_type); ;
    break;}
case 47:
#line 556 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, 0, yyvsp[-1].subplot_style_type); ;
    break;}
case 48:
#line 558 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[-1].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 49:
#line 560 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[0].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 50:
#line 562 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-2].subplot_using_type, yyvsp[-1].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 51:
#line 564 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-2].subplot_using_type, yyvsp[0].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 52:
#line 566 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[-2].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 53:
#line 568 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-2].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 54:
#line 570 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[0].tree_expression_type, yyvsp[-2].subplot_style_type); ;
    break;}
case 55:
#line 572 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-1].tree_expression_type, yyvsp[-2].subplot_style_type); ;
    break;}
case 56:
#line 576 "parse.y"
{
		    lexer_flags.in_plot_using = 0;
		    yyval.subplot_using_type = yyvsp[0].subplot_using_type;
		  ;
    break;}
case 57:
#line 581 "parse.y"
{
		    lexer_flags.in_plot_using = 0;
		    yyval.subplot_using_type = yyvsp[-1].subplot_using_type->set_format (yyvsp[0].tree_expression_type);
		  ;
    break;}
case 58:
#line 588 "parse.y"
{
		    subplot_using *tmp = new subplot_using ();
		    yyval.subplot_using_type = tmp->add_qualifier (yyvsp[0].tree_expression_type);
		  ;
    break;}
case 59:
#line 593 "parse.y"
{ yyval.subplot_using_type = yyvsp[-2].subplot_using_type->add_qualifier (yyvsp[0].tree_expression_type); ;
    break;}
case 60:
#line 597 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 61:
#line 601 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[0].tok_val->text ()); ;
    break;}
case 62:
#line 603 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[-1].tok_val->text (), yyvsp[0].tree_expression_type); ;
    break;}
case 63:
#line 605 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[-2].tok_val->text (), yyvsp[-1].tree_expression_type, yyvsp[0].tree_expression_type); ;
    break;}
case 64:
#line 609 "parse.y"
{ yyval.tree_expression_type = maybe_convert_to_ans_assign (yyvsp[0].tree_expression_type); ;
    break;}
case 65:
#line 613 "parse.y"
{
		    yyval.tree_global_command_type = new tree_global_command (yyvsp[0].tree_global_init_list_type, yyvsp[-1].tok_val->line (),
						  yyvsp[-1].tok_val->column ());
		  ;
    break;}
case 66:
#line 620 "parse.y"
{ yyval.tree_global_init_list_type = new tree_global_init_list (yyvsp[0].tree_global_type); ;
    break;}
case 67:
#line 622 "parse.y"
{
		    yyvsp[-2].tree_global_init_list_type->append (yyvsp[0].tree_global_type);
		    yyval.tree_global_init_list_type = yyvsp[-2].tree_global_init_list_type;
		  ;
    break;}
case 68:
#line 628 "parse.y"
{ yyval.tree_global_type = new tree_global (yyvsp[0].tree_identifier_type); ;
    break;}
case 69:
#line 630 "parse.y"
{
		    tree_simple_assignment_expression *tmp_ass;
		    tmp_ass = new tree_simple_assignment_expression
		      (yyvsp[-2].tree_identifier_type, yyvsp[0].tree_expression_type, 0, 0, yyvsp[-1].tok_val->line (), yyvsp[-1].tok_val->column ());
		    yyval.tree_global_type = new tree_global (tmp_ass);
		  ;
    break;}
case 71:
#line 640 "parse.y"
{
		    if (Vwarn_comma_in_global_decl)
		      warning ("comma in global declaration not\
 interpreted as a command separator");
		  ;
    break;}
case 72:
#line 648 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_plot_command_type; ;
    break;}
case 73:
#line 650 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_command_type; ;
    break;}
case 74:
#line 652 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_global_command_type; ;
    break;}
case 75:
#line 654 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_switch_command_type; ;
    break;}
case 76:
#line 656 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_if_command_type; ;
    break;}
case 77:
#line 658 "parse.y"
{
		    if (! (yyval.tree_command_type = make_unwind_command (yyvsp[-6].tok_val, yyvsp[-4].tree_statement_list_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 78:
#line 663 "parse.y"
{
		    if (! (yyval.tree_command_type = make_try_command (yyvsp[-6].tok_val, yyvsp[-4].tree_statement_list_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 79:
#line 668 "parse.y"
{
		    if (! (yyval.tree_command_type = make_while_command (yyvsp[-4].tok_val, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 80:
#line 673 "parse.y"
{
		    if (! (yyval.tree_command_type = make_for_command (yyvsp[-6].tok_val, yyvsp[-5].tree_index_expression_type, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 81:
#line 679 "parse.y"
{
		    if (! (yyval.tree_command_type = make_for_command (yyvsp[-9].tok_val, yyvsp[-6].tree_matrix_row_type, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 82:
#line 684 "parse.y"
{
		    if (! (yyval.tree_command_type = make_break_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 83:
#line 689 "parse.y"
{
		    if (! (yyval.tree_command_type = make_continue_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 84:
#line 694 "parse.y"
{
		    if (! (yyval.tree_command_type = make_return_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 85:
#line 701 "parse.y"
{
		    if (! (yyval.tree_if_command_type = finish_if_command (yyvsp[-2].tok_val, yyvsp[-1].tree_if_command_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 86:
#line 708 "parse.y"
{ yyval.tree_if_command_list_type = yyvsp[0].tree_if_command_list_type; ;
    break;}
case 87:
#line 710 "parse.y"
{
		    yyvsp[-1].tree_if_command_list_type->append (yyvsp[0].tree_if_clause_type);
		    yyval.tree_if_command_list_type = yyvsp[-1].tree_if_command_list_type;
		  ;
    break;}
case 88:
#line 717 "parse.y"
{ yyval.tree_if_command_list_type = start_if_command (yyvsp[-2].tree_expression_type, yyvsp[0].tree_statement_list_type); ;
    break;}
case 89:
#line 719 "parse.y"
{
		    yyvsp[-1].tree_if_command_list_type->append (yyvsp[0].tree_if_clause_type);
		    yyval.tree_if_command_list_type = yyvsp[-1].tree_if_command_list_type;
		  ;
    break;}
case 90:
#line 726 "parse.y"
{ yyval.tree_if_clause_type = make_elseif_clause (yyvsp[-2].tree_expression_type, yyvsp[0].tree_statement_list_type); ;
    break;}
case 91:
#line 730 "parse.y"
{ yyval.tree_if_clause_type = new tree_if_clause (yyvsp[0].tree_statement_list_type); ;
    break;}
case 92:
#line 734 "parse.y"
{
		    if (! (yyval.tree_switch_command_type = finish_switch_command (yyvsp[-4].tok_val, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_switch_case_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 93:
#line 741 "parse.y"
{ yyval.tree_switch_case_list_type = yyvsp[0].tree_switch_case_list_type; ;
    break;}
case 94:
#line 743 "parse.y"
{
		    yyvsp[-1].tree_switch_case_list_type->append (yyvsp[0].tree_switch_case_type);
		    yyval.tree_switch_case_list_type = yyvsp[-1].tree_switch_case_list_type;
		  ;
    break;}
case 95:
#line 750 "parse.y"
{ yyval.tree_switch_case_list_type = new tree_switch_case_list (yyvsp[0].tree_switch_case_type); ;
    break;}
case 96:
#line 752 "parse.y"
{
		    yyvsp[-1].tree_switch_case_list_type->append (yyvsp[0].tree_switch_case_type);
		    yyval.tree_switch_case_list_type = yyvsp[-1].tree_switch_case_list_type;
		  ;
    break;}
case 97:
#line 759 "parse.y"
{ yyval.tree_switch_case_type = make_switch_case (yyvsp[-2].tree_expression_type, yyvsp[0].tree_statement_list_type); ;
    break;}
case 98:
#line 763 "parse.y"
{ yyval.tree_switch_case_type = new tree_switch_case (yyvsp[0].tree_statement_list_type); ;
    break;}
case 99:
#line 767 "parse.y"
{ lexer_flags.maybe_screwed_again++; ;
    break;}
case 100:
#line 771 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 101:
#line 773 "parse.y"
{
		    yyerror ("invalid assignment to a number");
		    yyval.tree_expression_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 102:
#line 784 "parse.y"
{
		    if (! (yyval.tree_expression_type = yyvsp[0].tree_expression_type))
		      ABORT_PARSE;
		  ;
    break;}
case 103:
#line 791 "parse.y"
{ yyval.tree_expression_type = make_constant (NUM, yyvsp[0].tok_val); ;
    break;}
case 104:
#line 793 "parse.y"
{ yyval.tree_expression_type = make_constant (IMAG_NUM, yyvsp[0].tok_val); ;
    break;}
case 105:
#line 795 "parse.y"
{ yyval.tree_expression_type = make_constant (TEXT, yyvsp[0].tok_val); ;
    break;}
case 106:
#line 797 "parse.y"
{
		    yyvsp[-1].tree_expression_type->mark_in_parens ();
		    yyval.tree_expression_type = yyvsp[-1].tree_expression_type;
		  ;
    break;}
case 107:
#line 802 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_index_expression_type; ;
    break;}
case 108:
#line 804 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_index_expression_type; ;
    break;}
case 109:
#line 806 "parse.y"
{ yyval.tree_expression_type = finish_colon_expression (yyvsp[0].tree_colon_expression_type); ;
    break;}
case 110:
#line 808 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 111:
#line 810 "parse.y"
{ yyval.tree_expression_type = new tree_constant (Matrix ()); ;
    break;}
case 112:
#line 812 "parse.y"
{ yyval.tree_expression_type = new tree_constant (Matrix ()); ;
    break;}
case 113:
#line 814 "parse.y"
{ yyval.tree_expression_type = make_prefix_op (PLUS_PLUS, yyvsp[0].tree_identifier_type, yyvsp[-1].tok_val); ;
    break;}
case 114:
#line 816 "parse.y"
{ yyval.tree_expression_type = make_prefix_op (MINUS_MINUS, yyvsp[0].tree_identifier_type, yyvsp[-1].tok_val); ;
    break;}
case 115:
#line 818 "parse.y"
{ yyval.tree_expression_type = make_unary_op (EXPR_NOT, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val); ;
    break;}
case 116:
#line 820 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 117:
#line 822 "parse.y"
{ yyval.tree_expression_type = make_unary_op ('-', yyvsp[0].tree_expression_type, yyvsp[-1].tok_val); ;
    break;}
case 118:
#line 824 "parse.y"
{ yyval.tree_expression_type = make_simple_assignment (yyvsp[-2].tree_index_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 119:
#line 826 "parse.y"
{
		    if (! (yyval.tree_expression_type = make_multi_val_ret (yyvsp[-3].tree_matrix_row_type, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 120:
#line 831 "parse.y"
{ yyval.tree_expression_type = make_postfix_op (PLUS_PLUS, yyvsp[-1].tree_identifier_type, yyvsp[0].tok_val); ;
    break;}
case 121:
#line 833 "parse.y"
{ yyval.tree_expression_type = make_postfix_op (MINUS_MINUS, yyvsp[-1].tree_identifier_type, yyvsp[0].tok_val); ;
    break;}
case 122:
#line 835 "parse.y"
{ yyval.tree_expression_type = make_unary_op (QUOTE, yyvsp[-1].tree_expression_type, yyvsp[0].tok_val); ;
    break;}
case 123:
#line 837 "parse.y"
{ yyval.tree_expression_type = make_unary_op (TRANSPOSE, yyvsp[-1].tree_expression_type, yyvsp[0].tok_val); ;
    break;}
case 124:
#line 839 "parse.y"
{ yyval.tree_expression_type = make_binary_op (POW, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 125:
#line 841 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EPOW, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 126:
#line 843 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('+', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 127:
#line 845 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('-', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 128:
#line 847 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('*', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 129:
#line 849 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('/', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 130:
#line 851 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('+', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 131:
#line 853 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('-', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 132:
#line 855 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EMUL, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 133:
#line 857 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 134:
#line 859 "parse.y"
{ yyval.tree_expression_type = make_binary_op (LEFTDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 135:
#line 861 "parse.y"
{ yyval.tree_expression_type = make_binary_op (ELEFTDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 136:
#line 863 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_LT, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 137:
#line 865 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_LE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 138:
#line 867 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_EQ, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 139:
#line 869 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_GE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 140:
#line 871 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_GT, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 141:
#line 873 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_NE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 142:
#line 875 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_AND, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 143:
#line 877 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_OR, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 144:
#line 879 "parse.y"
{ yyval.tree_expression_type = make_boolean_op (EXPR_AND_AND, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 145:
#line 881 "parse.y"
{ yyval.tree_expression_type = make_boolean_op (EXPR_OR_OR, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 146:
#line 885 "parse.y"
{
		    yyval.tree_colon_expression_type = new tree_colon_expression
		      (yyvsp[-2].tree_expression_type, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val->line (), yyvsp[-1].tok_val->column ());
		  ;
    break;}
case 147:
#line 890 "parse.y"
{
		    if (! (yyval.tree_colon_expression_type = yyvsp[-2].tree_colon_expression_type->chain (yyvsp[0].tree_expression_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 148:
#line 897 "parse.y"
{
		    yyval.tree_index_expression_type = new tree_index_expression
		      (yyvsp[-1].tree_identifier_type, yyvsp[0].tree_argument_list_type, yyvsp[-1].tree_identifier_type->line (), yyvsp[-1].tree_identifier_type->column ());
		  ;
    break;}
case 149:
#line 904 "parse.y"
{
		    tree_constant *tmp = make_constant (TEXT, yyvsp[0].tok_val);
		    yyval.tree_argument_list_type = new tree_argument_list (tmp);
		  ;
    break;}
case 150:
#line 909 "parse.y"
{
		    tree_constant *tmp = make_constant (TEXT, yyvsp[0].tok_val);
		    yyvsp[-1].tree_argument_list_type->append (tmp);
		    yyval.tree_argument_list_type = yyvsp[-1].tree_argument_list_type;
		  ;
    break;}
case 151:
#line 919 "parse.y"
{ curr_sym_tab = global_sym_tab; ;
    break;}
case 152:
#line 923 "parse.y"
{ lexer_flags.looking_at_return_list = 1; ;
    break;}
case 153:
#line 927 "parse.y"
{ curr_sym_tab = tmp_local_sym_tab; ;
    break;}
case 154:
#line 931 "parse.y"
{ lexer_flags.maybe_screwed = 0; ;
    break;}
case 155:
#line 935 "parse.y"
{ lexer_flags.maybe_screwed = 1; ;
    break;}
case 156:
#line 939 "parse.y"
{
		    curr_sym_tab = top_level_sym_tab;
		    lexer_flags.defining_func = 0;
		    yyval.tree_command_type = 0;
		  ;
    break;}
case 157:
#line 945 "parse.y"
{
		    curr_sym_tab = top_level_sym_tab;
		    lexer_flags.defining_func = 0;
		    yyval.tree_command_type = 0;
		  ;
    break;}
case 158:
#line 953 "parse.y"
{ yyval.tree_function_type = finish_function_def (yyvsp[-4].tok_val, yyvsp[0].tree_function_type); ;
    break;}
case 159:
#line 955 "parse.y"
{ yyval.tree_function_type = finish_function_def (yyvsp[-3].tree_parameter_list_type, yyvsp[0].tree_function_type); ;
    break;}
case 161:
#line 962 "parse.y"
{
		    lexer_flags.looking_at_return_list = 0;
		    yyval.tree_parameter_list_type = new tree_parameter_list ();
		  ;
    break;}
case 162:
#line 967 "parse.y"
{
		    lexer_flags.looking_at_return_list = 0;
		    tree_parameter_list *tmp = new tree_parameter_list ();
		    tmp->mark_varargs_only ();
		    yyval.tree_parameter_list_type = tmp;
		  ;
    break;}
case 163:
#line 974 "parse.y"
{
		    lexer_flags.looking_at_return_list = 0;
		    yyval.tree_parameter_list_type = yyvsp[-1].tree_parameter_list_type;
		  ;
    break;}
case 164:
#line 979 "parse.y"
{
		    lexer_flags.looking_at_return_list = 0;
		    yyvsp[-3].tree_parameter_list_type->mark_varargs ();
		    yyval.tree_parameter_list_type = yyvsp[-3].tree_parameter_list_type;
		  ;
    break;}
case 165:
#line 987 "parse.y"
{ yyval.tree_parameter_list_type = new tree_parameter_list (yyvsp[0].tree_identifier_type); ;
    break;}
case 166:
#line 989 "parse.y"
{
		    yyerror ("invalid function return list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 167:
#line 995 "parse.y"
{
		    yyvsp[-2].tree_parameter_list_type->append (yyvsp[0].tree_identifier_type);
		    yyval.tree_parameter_list_type = yyvsp[-2].tree_parameter_list_type;
		  ;
    break;}
case 168:
#line 1002 "parse.y"
{
		    if (! (yyval.tree_function_type = frob_function_def (yyvsp[-3].tree_identifier_type, yyvsp[0].tree_function_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 169:
#line 1009 "parse.y"
{ yyval.tree_function_type = start_function_def (yyvsp[-3].tree_parameter_list_type, yyvsp[-1].tree_statement_list_type); ;
    break;}
case 170:
#line 1011 "parse.y"
{ yyval.tree_function_type = start_function_def (0, yyvsp[-1].tree_statement_list_type); ;
    break;}
case 171:
#line 1015 "parse.y"
{
		    if (check_end (yyvsp[0].tok_val, token::function_end))
		      ABORT_PARSE;

		    if (reading_fcn_file)
		      check_for_garbage_after_fcn_def ();
		  ;
    break;}
case 172:
#line 1023 "parse.y"
{
		    if (! (reading_fcn_file || reading_script_file))
		      YYABORT;
		  ;
    break;}
case 173:
#line 1030 "parse.y"
{
		    lexer_flags.looking_at_indirect_ref = 0;
		    yyval.tree_indirect_ref_type = yyvsp[0].tree_indirect_ref_type;
		  ;
    break;}
case 174:
#line 1036 "parse.y"
{
		    yyval.tree_indirect_ref_type = new tree_indirect_ref (yyvsp[0].tree_identifier_type, yyvsp[0].tree_identifier_type->line (),
						yyvsp[0].tree_identifier_type->column ());
		  ;
    break;}
case 175:
#line 1041 "parse.y"
{ lexer_flags.looking_at_indirect_ref = 1; ;
    break;}
case 176:
#line 1042 "parse.y"
{ yyval.tree_indirect_ref_type = new tree_indirect_ref (yyvsp[-3].tree_indirect_ref_type, yyvsp[0].tok_val->text ()); ;
    break;}
case 177:
#line 1046 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[0].tree_indirect_ref_type, 0); ;
    break;}
case 178:
#line 1048 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[-2].tree_indirect_ref_type, 0); ;
    break;}
case 179:
#line 1050 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[-3].tree_indirect_ref_type, yyvsp[-1].tree_argument_list_type); ;
    break;}
case 180:
#line 1052 "parse.y"
{
		    yyerror ("use `(\' and `)\' as index operators, not\
 `[\' and `]\'"); 
		    yyval.tree_index_expression_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 181:
#line 1061 "parse.y"
{ lexer_flags.looking_at_parameter_list = 1; ;
    break;}
case 182:
#line 1065 "parse.y"
{ lexer_flags.looking_at_parameter_list = 0; ;
    break;}
case 183:
#line 1069 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    yyval.tree_parameter_list_type = 0;
		  ;
    break;}
case 184:
#line 1074 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    tree_parameter_list *tmp = new tree_parameter_list ();
		    tmp->mark_varargs_only ();
		    yyval.tree_parameter_list_type = tmp;
		  ;
    break;}
case 185:
#line 1081 "parse.y"
{
		    lexer_flags.looking_at_parameter_list = 0;
		    lexer_flags.quote_is_transpose = 0;
		    yyvsp[-1].tree_parameter_list_type->mark_as_formal_parameters ();
		    yyval.tree_parameter_list_type = yyvsp[-1].tree_parameter_list_type;
		  ;
    break;}
case 186:
#line 1088 "parse.y"
{
		    lexer_flags.looking_at_parameter_list = 0;
		    lexer_flags.quote_is_transpose = 0;
		    yyvsp[-3].tree_parameter_list_type->mark_as_formal_parameters ();
		    yyvsp[-3].tree_parameter_list_type->mark_varargs ();
		    yyval.tree_parameter_list_type = yyvsp[-3].tree_parameter_list_type;
		  ;
    break;}
case 187:
#line 1098 "parse.y"
{ yyval.tree_parameter_list_type = new tree_parameter_list (yyvsp[0].tree_identifier_type); ;
    break;}
case 188:
#line 1100 "parse.y"
{
		    yyvsp[-2].tree_parameter_list_type->append (yyvsp[0].tree_identifier_type);
		    yyval.tree_parameter_list_type = yyvsp[-2].tree_parameter_list_type;
		  ;
    break;}
case 189:
#line 1105 "parse.y"
{
		    yyerror ("invalid parameter list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 190:
#line 1111 "parse.y"
{
		    yyerror ("invalid parameter list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 191:
#line 1119 "parse.y"
{
		    yyval.tree_identifier_type = new tree_identifier
		      (yyvsp[0].tok_val->sym_rec (), yyvsp[0].tok_val->line (), yyvsp[0].tok_val->column ());
		  ;
    break;}
case 192:
#line 1126 "parse.y"
{
		    tree_constant *colon =
		      new tree_constant (tree_constant::magic_colon_t);
		    yyval.tree_argument_list_type = new tree_argument_list (colon);
		  ;
    break;}
case 193:
#line 1132 "parse.y"
{ yyval.tree_argument_list_type = new tree_argument_list (yyvsp[0].tree_expression_type); ;
    break;}
case 194:
#line 1134 "parse.y"
{
		    tree_constant *all_va_args =
		      new tree_constant (tree_constant::all_va_args_t);
		    yyval.tree_argument_list_type = new tree_argument_list (all_va_args);
		  ;
    break;}
case 195:
#line 1140 "parse.y"
{
		    tree_constant *colon =
		      new tree_constant (tree_constant::magic_colon_t);
		    yyvsp[-2].tree_argument_list_type->append (colon);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 196:
#line 1147 "parse.y"
{
		    yyvsp[-2].tree_argument_list_type->append (yyvsp[0].tree_expression_type);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 197:
#line 1152 "parse.y"
{
		    tree_constant *all_va_args =
		      new tree_constant (tree_constant::all_va_args_t);
		    yyvsp[-2].tree_argument_list_type->append (all_va_args);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 198:
#line 1161 "parse.y"
{ yyval.tree_expression_type = finish_matrix (yyvsp[-1].tree_matrix_type); ;
    break;}
case 199:
#line 1165 "parse.y"
{ yyval.tree_matrix_type = yyvsp[0].tree_matrix_type; ;
    break;}
case 200:
#line 1167 "parse.y"
{ yyval.tree_matrix_type = yyvsp[-1].tree_matrix_type; ;
    break;}
case 201:
#line 1171 "parse.y"
{ yyval.tree_matrix_type = new tree_matrix (yyvsp[0].tree_matrix_row_type); ;
    break;}
case 202:
#line 1173 "parse.y"
{
		    yyvsp[-2].tree_matrix_type->append (yyvsp[0].tree_matrix_row_type);
		    yyval.tree_matrix_type = yyvsp[-2].tree_matrix_type;
		  ;
    break;}
case 203:
#line 1180 "parse.y"
{ yyval.tree_matrix_row_type = yyvsp[0].tree_matrix_row_type; ;
    break;}
case 204:
#line 1182 "parse.y"
{ yyval.tree_matrix_row_type = yyvsp[-1].tree_matrix_row_type; ;
    break;}
case 205:
#line 1186 "parse.y"
{ yyval.tree_matrix_row_type = new tree_matrix_row (yyvsp[0].tree_expression_type); ;
    break;}
case 206:
#line 1188 "parse.y"
{
		    yyvsp[-2].tree_matrix_row_type->append (yyvsp[0].tree_expression_type);
		    yyval.tree_matrix_row_type = yyvsp[-2].tree_matrix_row_type;
		  ;
    break;}
case 207:
#line 1195 "parse.y"
{ yyval.sep_type = ','; ;
    break;}
case 208:
#line 1197 "parse.y"
{ yyval.sep_type = ';'; ;
    break;}
case 209:
#line 1199 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 210:
#line 1201 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 211:
#line 1205 "parse.y"
{ yyval.sep_type = 0; ;
    break;}
case 212:
#line 1207 "parse.y"
{ yyval.sep_type = yyvsp[0].sep_type; ;
    break;}
case 213:
#line 1211 "parse.y"
{ yyval.sep_type = ','; ;
    break;}
case 214:
#line 1213 "parse.y"
{ yyval.sep_type = ';'; ;
    break;}
case 215:
#line 1215 "parse.y"
{ yyval.sep_type = '\n'; ;
    break;}
case 216:
#line 1217 "parse.y"
{ yyval.sep_type = '\r'; ;
    break;}
case 217:
#line 1219 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 218:
#line 1221 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 219:
#line 1223 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 220:
#line 1225 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 221:
#line 1229 "parse.y"
{ yyval.sep_type = 0; ;
    break;}
case 222:
#line 1231 "parse.y"
{ yyval.sep_type = yyvsp[0].sep_type; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1234 "parse.y"


// Generic error messages.

static void
yyerror (char *s)
{
  int err_col = current_input_column - 1;

  ostrstream output_buf;

  if (reading_fcn_file || reading_script_file)
    output_buf << "parse error near line " << input_line_number
	       << " of file " << curr_fcn_file_full_name;
  else
    output_buf << "parse error:";

  if (s && strcmp (s, "parse error") != 0)
    output_buf << "\n\n  " << s;

  output_buf << "\n\n";

  if (! current_input_line.empty ())
    {
      size_t len = current_input_line.length ();

      if (current_input_line[len-1] == '\n')
        current_input_line.resize (len-1);

// Print the line, maybe with a pointer near the error token.

      output_buf << ">>> " << current_input_line << "\n";

      if (err_col == 0)
	err_col = len;

      for (int i = 0; i < err_col + 3; i++)
	output_buf << " ";

      output_buf << "^";
    }

  output_buf << "\n" << ends;

  char *msg = output_buf.str ();

  parse_error ("%s", msg);

  delete [] msg;
}

// Error mesages for mismatched end tokens.

static void
end_error (char *type, token::end_tok_type ettype, int l, int c)
{
  static char *fmt = "`%s' command matched by `%s' near line %d column %d";

  switch (ettype)
    {
    case token::simple_end:
      error (fmt, type, "end", l, c);
      break;

    case token::for_end:
      error (fmt, type, "endfor", l, c);
      break;

    case token::function_end:
      error (fmt, type, "endfunction", l, c);
      break;

    case token::if_end:
      error (fmt, type, "endif", l, c);
      break;

    case token::while_end:
      error (fmt, type, "endwhile", l, c); 
      break;

    case token::unwind_protect_end:
      error (fmt, type, "end_unwind_protect", l, c); 
      break;

    default:
      panic_impossible ();
      break;
    }
}

// Check to see that end tokens are properly matched.

static int
check_end (token *tok, token::end_tok_type expected)
{
  token::end_tok_type ettype = tok->ettype ();
  if (ettype != expected && ettype != token::simple_end)
    {
      yyerror ("parse error");

      int l = tok->line ();
      int c = tok->column ();

      switch (expected)
	{
	case token::for_end:
	  end_error ("for", ettype, l, c);
	  break;

	case token::function_end:
	  end_error ("function", ettype, l, c);
	  break;

	case token::if_end:
	  end_error ("if", ettype, l, c);
	  break;

	case token::try_catch_end:
	  end_error ("try", ettype, l, c);
	  break;

	case token::switch_end:
	  end_error ("switch", ettype, l, c);
	  break;

	case token::unwind_protect_end:
	  end_error ("unwind_protect", ettype, l, c);
	  break;

	case token::while_end:
	  end_error ("while", ettype, l, c);
	  break;

	default:
	  panic_impossible ();
	  break;
	}
      return 1;
    }
  else
    return 0;
}

// Try to figure out early if an expression should become an
// assignment to the built-in variable ans.
//
// Need to make sure that the expression is not already an identifier
// that has a name, or an assignment expression.
//
// Note that an expression can not be just an identifier now -- it
// must at least be an index expression (see the definition of the
// non-terminal variable above).

static tree_expression *
maybe_convert_to_ans_assign (tree_expression *expr)
{
  if (expr->is_index_expression ())
    {
      expr->mark_for_possible_ans_assign ();
      return expr;
    }
  else if (expr->is_assignment_expression ()
	   || expr->is_prefix_expression ())
    {
      return expr;
    }
  else
    {
      // XXX FIXME XXX -- making ans_id static, passing its address to
      // tree_simple_assignment_expression along with a flag to not
      // delete it seems to create a memory leak.  Hmm.

      static symbol_record *sr = global_sym_tab->lookup ("ans", 1, 0);
      tree_identifier *ans_id = new tree_identifier (sr);

      int l = expr->line ();
      int c = expr->column ();

      return new tree_simple_assignment_expression (ans_id, expr, 0, 1, l, c);
    }
}

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.

static void
maybe_warn_assign_as_truth_value (tree_expression *expr)
{
  if (Vwarn_assign_as_truth_value
      && expr->is_assignment_expression ()
      && expr->is_in_parens () < 2)
    {
      warning ("suggest parenthesis around assignment used as truth value");
    }
}

// Maybe print a warning about switch labels that aren't constants.

static void
maybe_warn_variable_switch_label (tree_expression *expr)
{
  if (Vwarn_variable_switch_label && ! expr->is_constant ())
    {
      warning ("variable switch label");
    }
}

// Create a plot command.

static tree_plot_command *
make_plot_command (token *tok, plot_limits *range, subplot_list *list)
{
  if (range)
    {
      if (tok->pttype () == token::replot)
	{
	  yyerror ("cannot specify new ranges with replot");
	  return 0;
	}
    }
  else if (! list && tok->pttype () != token::replot)
    {
      yyerror ("must have something to plot");
      return 0;
    }

  lexer_flags.plotting = 0;
  lexer_flags.past_plot_range = 0;
  lexer_flags.in_plot_range = 0;
  lexer_flags.in_plot_using = 0;
  lexer_flags.in_plot_style = 0;
  
  return new tree_plot_command (list, range, tok->pttype ());
}

static tree_expression *
fold (tree_binary_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *op1 = e->lhs ();
  tree_expression *op2 = e->rhs ();

  if (op1->is_constant () && op2->is_constant ())
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

static tree_expression *
fold (tree_unary_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *op1 = e->operand ();

  if (op1->is_constant ())
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

// Finish building a range.

static tree_expression *
finish_colon_expression (tree_colon_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *base = e->base ();
  tree_expression *limit = e->limit ();
  tree_expression *incr = e->increment ();

  if (base->is_constant () && limit->is_constant ()
      && (! incr || (incr && incr->is_constant ())))
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

// Make a constant.

static tree_constant *
make_constant (int op, token *tok_val)
{
  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_constant *retval;

  switch (op)
    {
    case NUM:
      {
	retval = new tree_constant (tok_val->number (), l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case IMAG_NUM:
      {
	Complex C (0.0, tok_val->number ());
	retval = new tree_constant (C, l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case TEXT:
      retval = new tree_constant (tok_val->text (), l, c);
      break;

    default:
      panic_impossible ();
      break;
    }

  return retval;
}

// Build a binary expression.

static tree_expression *
make_binary_op (int op, tree_expression *op1, token *tok_val,
		tree_expression *op2)
{
  tree_binary_expression::type t;

  switch (op)
    {
    case POW:
      t = tree_binary_expression::power;
      break;

    case EPOW:
      t = tree_binary_expression::elem_pow;
      break;

    case '+':
      t = tree_binary_expression::add;
      break;

    case '-':
      t = tree_binary_expression::subtract;
      break;

    case '*':
      t = tree_binary_expression::multiply;
      break;

    case '/':
      t = tree_binary_expression::divide;
      break;

    case EMUL:
      t = tree_binary_expression::el_mul;
      break;

    case EDIV:
      t = tree_binary_expression::el_div;
      break;

    case LEFTDIV:
      t = tree_binary_expression::leftdiv;
      break;

    case ELEFTDIV:
      t = tree_binary_expression::el_leftdiv;
      break;

    case EXPR_LT:
      t = tree_binary_expression::cmp_lt;
      break;

    case EXPR_LE:
      t = tree_binary_expression::cmp_le;
      break;

    case EXPR_EQ:
      t = tree_binary_expression::cmp_eq;
      break;

    case EXPR_GE:
      t = tree_binary_expression::cmp_ge;
      break;

    case EXPR_GT:
      t = tree_binary_expression::cmp_gt;
      break;

    case EXPR_NE:
      t = tree_binary_expression::cmp_ne;
      break;

    case EXPR_AND:
      t = tree_binary_expression::and;
      break;

    case EXPR_OR:
      t = tree_binary_expression::or;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_binary_expression *e
    = new tree_binary_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a boolean expression.

static tree_expression *
make_boolean_op (int op, tree_expression *op1, token *tok_val,
		 tree_expression *op2)
{
  tree_boolean_expression::type t;

  switch (op)
    {
    case EXPR_AND_AND:
      t = tree_boolean_expression::and;
      break;

    case EXPR_OR_OR:
      t = tree_boolean_expression::or;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_boolean_expression *e
    = new tree_boolean_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a prefix expression.

static tree_expression *
make_prefix_op (int op, tree_identifier *op1, token *tok_val)
{
  tree_prefix_expression::type t;

  switch (op)
    {
    case PLUS_PLUS:
      t = tree_prefix_expression::increment;
      break;

    case MINUS_MINUS:
      t = tree_prefix_expression::decrement;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  return new tree_prefix_expression (op1, l, c, t);
}

// Build a postfix expression.

static tree_expression *
make_postfix_op (int op, tree_identifier *op1, token *tok_val)
{
  tree_postfix_expression::type t;

  switch (op)
    {
    case PLUS_PLUS:
      t = tree_postfix_expression::increment;
      break;

    case MINUS_MINUS:
      t = tree_postfix_expression::decrement;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  return new tree_postfix_expression (op1, l, c, t);
}

// Build a unary expression.

static tree_expression *
make_unary_op (int op, tree_expression *op1, token *tok_val)
{
  tree_unary_expression::type t;

  switch (op)
    {
    case QUOTE:
      t = tree_unary_expression::hermitian;
      break;

    case TRANSPOSE:
      t = tree_unary_expression::transpose;
      break;

    case EXPR_NOT:
      t = tree_unary_expression::not;
      break;

    case '-':
      t = tree_unary_expression::uminus;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_unary_expression *e
    = new tree_unary_expression (op1, l, c, t);

  return fold (e);
}

// Build an unwind-protect command.

static tree_command *
make_unwind_command (token *unwind_tok, tree_statement_list *body,
		     tree_statement_list *cleanup, token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::unwind_protect_end))
    {
      int l = unwind_tok->line ();
      int c = unwind_tok->column ();

      retval = new tree_unwind_protect_command (body, cleanup, l, c);
    }

  return retval;
}

// Build a try-catch command.

static tree_command *
make_try_command (token *try_tok, tree_statement_list *body,
		  tree_statement_list *cleanup, token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::try_catch_end))
    {
      int l = try_tok->line ();
      int c = try_tok->column ();

      retval = new tree_try_catch_command (body, cleanup, l, c);
    }

  return retval;
}

// Build a while command.

static tree_command *
make_while_command (token *while_tok, tree_expression *expr,
		    tree_statement_list *body, token *end_tok)
{
  tree_command *retval = 0;

  maybe_warn_assign_as_truth_value (expr);

  if (! check_end (end_tok, token::while_end))
    {
      lexer_flags.looping--;

      int l = while_tok->line ();
      int c = while_tok->column ();

      retval = new tree_while_command (expr, body, l, c);
    }

  return retval;
}

// Build a for command.

static tree_command *
make_for_command (token *for_tok, tree_index_expression *var,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::for_end))
    {
      lexer_flags.looping--;

      int l = for_tok->line ();
      int c = for_tok->column ();

      retval = new tree_for_command (var, expr, body, l, c);
    }

  return retval;
}

// Build a for command a different way.

static tree_command *
make_for_command (token *for_tok, tree_matrix_row *mr,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::for_end))
    {
      lexer_flags.looping--;

      tree_return_list *id_list = mr->to_return_list ();

      int l = for_tok->line ();
      int c = for_tok->column ();

      retval = new tree_for_command (id_list, expr, body, l, c);
    }

  return retval;
}

// Build a break command.

static tree_command *
make_break_command (token *break_tok)
{
  tree_command *retval = 0;

  int l = break_tok->line ();
  int c = break_tok->column ();

  if (lexer_flags.looping || lexer_flags.defining_func || reading_script_file)
    retval = new tree_break_command (l, c);
  else
    retval = new tree_no_op_command ("break", l, c);

   return retval;
}

// Build a continue command.

static tree_command *
make_continue_command (token *continue_tok)
{
  tree_command *retval = 0;

  int l = continue_tok->line ();
  int c = continue_tok->column ();

  if (lexer_flags.looping)
    retval = new tree_continue_command (l, c);
  else
    retval = new tree_no_op_command ("continue", l, c);

  return retval;
}

// Build a return command.

static tree_command *
make_return_command (token *return_tok)
{
  tree_command *retval = 0;

  int l = return_tok->line ();
  int c = return_tok->column ();

  if (lexer_flags.defining_func || reading_script_file)
    retval = new tree_return_command (l, c);
  else
    retval = new tree_no_op_command ("return", l, c);

  return retval;
}

// Start an if command.

static tree_if_command_list *
start_if_command (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_assign_as_truth_value (expr);

  tree_if_clause *t = new tree_if_clause (expr, list);

  return new tree_if_command_list (t);
}

// Finish an if command.

static tree_if_command *
finish_if_command (token *if_tok, tree_if_command_list *list,
		   token *end_tok)
{
  tree_if_command *retval = 0;

  if (! check_end (end_tok, token::if_end))
    {
      int l = if_tok->line ();
      int c = if_tok->column ();

      retval = new tree_if_command (list, l, c);
    }

  return retval;
}

// Build an elseif clause.

static tree_if_clause *
make_elseif_clause (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_assign_as_truth_value (expr);

  return new tree_if_clause (expr, list);
}

// Finish a switch command.

static tree_switch_command *
finish_switch_command (token *switch_tok, tree_expression *expr,
		       tree_switch_case_list *list, token *end_tok)
{
  tree_switch_command *retval = 0;

  if (! check_end (end_tok, token::switch_end))
    {
      int l = switch_tok->line ();
      int c = switch_tok->column ();

      retval = new tree_switch_command (expr, list, l, c);
    }

  return retval;
}

// Build a switch case.

static tree_switch_case *
make_switch_case (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_variable_switch_label (expr);

  return new tree_switch_case (expr, list);
}

// Build an assignment to a variable.

static tree_expression *
make_simple_assignment (tree_index_expression *var, token *eq_tok,
			tree_expression *expr)
{
  int l = eq_tok->line ();
  int c = eq_tok->column ();

  return new tree_simple_assignment_expression (var, expr, 0, 0, l, c);
}

// Make an expression that handles assignment of multiple values.

static tree_expression *
make_multi_val_ret (tree_matrix_row *mr, tree_expression *rhs, token *eq_tok)
{
// Convert the matrix list to a list of identifiers.  If that fails,
// we can abort here, without losing anything -- no other possible
// syntax is valid if we've seen the equals sign as the next token
// after the `]'. 

  tree_expression *retval = 0;

  lexer_flags.maybe_screwed_again--;

  tree_return_list *id_list = mr->to_return_list ();

  if (id_list)
    {
      int list_len = id_list->length ();

      if (list_len == 1)
	{
	  tree_index_expression *lhs = id_list->remove_front ();

	  int l = eq_tok->line ();
	  int c = eq_tok->column ();

	  retval = new tree_simple_assignment_expression (lhs, rhs,
							  0, 0, l, c);
	}
      else if (list_len > 1)
	{
	  if (rhs->is_multi_val_ret_expression ())
	    {
	      tree_multi_val_ret *t = (tree_multi_val_ret *) rhs;

	      int l = eq_tok->line ();
	      int c = eq_tok->column ();

	      retval = new tree_multi_assignment_expression (id_list, t,
							     0, l, c);
	    }
	  else
	    yyerror ("RHS must be an expression that returns multiple values");
	}
      else
	panic_impossible ();
    }
  else
    yyerror ("invalid identifier list for assignment");

  return retval;
}

// Begin defining a function.

static tree_function *
start_function_def (tree_parameter_list *param_list,
		    tree_statement_list *body)
{
  body->mark_as_function_body ();

  tree_function *fcn = new tree_function (body, curr_sym_tab);

  fcn->define_param_list (param_list);

  return fcn;
}

// Do most of the work for defining a function.

static tree_function *
frob_function_def (tree_identifier *id, tree_function *fcn)
{
  string id_name = id->name ();

  // If input is coming from a file, issue a warning if the name of
  // the file does not match the name of the function stated in the
  // file.  Matlab doesn't provide a diagnostic (it ignores the stated
  // name).

  fcn->stash_function_name (id_name);

  if (reading_fcn_file)
    {
      if (curr_fcn_file_name != id_name)
	{
	  if (Vwarn_function_name_clash)
	    warning ("function name `%s' does not agree with function\
 file name `%s'", id_name.c_str (), curr_fcn_file_full_name.c_str ());

	  global_sym_tab->rename (id_name, curr_fcn_file_name);

	  if (error_state)
	    return 0;

	  id_name = id->name ();
	}

      fcn->stash_function_name (id_name);
      fcn->stash_fcn_file_name ();
      fcn->stash_fcn_file_time (time (0));
      fcn->mark_as_system_fcn_file ();
    }
  else if (! (input_from_tmp_history_file || input_from_startup_file)
	   && reading_script_file
	   && curr_fcn_file_name == id_name)
    {
      warning ("function `%s' defined within script file `%s'",
	       id_name.c_str (), curr_fcn_file_full_name.c_str ());
    }

  top_level_sym_tab->clear (id_name);

  id->define (fcn);

  id->document (help_buf);

  return fcn;
}

// Finish defining a function.

static tree_function *
finish_function_def (token *var, tree_function *fcn)
{
  symbol_record *sr = var->sym_rec ();

  int l = var->line ();
  int c = var->column ();

  tree_identifier *tmp = new tree_identifier (sr, l, c);

  tree_parameter_list *tpl = new tree_parameter_list (tmp);

  tpl->mark_as_formal_parameters ();

  return fcn->define_ret_list (tpl);
}

// Finish defining a function a different way.

static tree_function *
finish_function_def (tree_parameter_list *ret_list, tree_function *fcn)
{
  ret_list->mark_as_formal_parameters ();

  return fcn->define_ret_list (ret_list);
}

static tree_index_expression *
make_index_expression (tree_indirect_ref *indir, tree_argument_list *args)
{
  tree_index_expression *retval = 0;

  int l = indir->line ();
  int c = indir->column ();

  if (indir->is_identifier_only ())
    {
      indir->preserve_identifier ();
      retval = new tree_index_expression (indir->ident (), args, l, c);
      delete indir;
    }
  else
    retval =  new tree_index_expression (indir, args, l, c);

  return retval;
}

// Finish building a matrix list.

static tree_expression *
finish_matrix (tree_matrix *m)
{
  tree_expression *retval = 0;

  lexer_flags.maybe_screwed_again--;

  if (m->all_elements_are_constant ())
    {
      octave_value tmp = m->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  m->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete m;

	  retval = tc_retval;
	}
      else
	delete m;
    }
  else
    retval = m;

  return retval;
}

static void
maybe_warn_missing_semi (tree_statement_list *t)
{
  if (lexer_flags.defining_func && Vwarn_missing_semicolon)
    {
      tree_statement *tmp = t->rear();

      if (tmp->is_expression ())
	warning ("missing semicolon near line %d, column %d in file `%s'",
		 tmp->line (), tmp->column (),
		 curr_fcn_file_full_name.c_str ());
    }
}

static void
set_stmt_print_flag (tree_statement_list *list, char sep,
		     bool warn_missing_semi)
{
  switch (sep)
    {
    case ';':
      {
	tree_statement *tmp = list->rear ();
	tmp->set_print_flag (0);
      }
      break;

    case 0:
    case ',':
    case '\n':
    case '\r':
      if (warn_missing_semi)
	maybe_warn_missing_semi (list);
      break;

    default:
      warning ("unrecognized separator type!");
      break;
    }
}

static int
warn_assign_as_truth_value (void)
{
  Vwarn_assign_as_truth_value
    = check_preference ("warn_assign_as_truth_value");

  return 0;
}

static int
warn_comma_in_global_decl (void)
{
  Vwarn_comma_in_global_decl = check_preference ("warn_comma_in_global_decl");

  return 0;
}

static int
warn_function_name_clash (void)
{
  Vwarn_function_name_clash = check_preference ("warn_function_name_clash");

  return 0;
}

static int
warn_missing_semicolon (void)
{
  Vwarn_missing_semicolon = check_preference ("warn_missing_semicolon");

  return 0;
}

static int
warn_variable_switch_label (void)
{
  Vwarn_variable_switch_label
    = check_preference ("warn_variable_switch_label");

  return 0;
}

void
symbols_of_parse (void)
{
  DEFVAR (warn_assign_as_truth_value, 1.0, 0, warn_assign_as_truth_value,
    "produce warning for assignments used as truth values");

  DEFVAR (warn_comma_in_global_decl, 1.0, 0, warn_comma_in_global_decl,
    "produce warning for commas in global declarations");

  DEFVAR (warn_function_name_clash, 1.0, 0, warn_function_name_clash,
    "produce warning if function name conflicts with file name");

  DEFVAR (warn_missing_semicolon, 0.0, 0, warn_missing_semicolon,
    "produce a warning if a statement in a function file is not\n\
terminated with a semicolon");

  DEFVAR (warn_variable_switch_label, 0.0, 0, warn_variable_switch_label,
    "produce warning for variables used as switch labels");
}

/*
;;; Local Variables: ***
;;; mode: text ***
;;; End: ***
*/
